param(
	$solutionPath = $(throw 'solutionPath must be supplied')
)
$erroractionpreference="stop"
pushd "$pwd\..\..\bin\"
trap { popd; }

write-host Loading SNAK dlls
dir *.dll | % { [reflection.assembly]::loadfrom($_.FullName) } | out-host

$solution = [snak.core.solutionfactory]::GetSolution("$solutionPath");
$solution.GetProjectsFor("Debug|Any CPU") | 
	? { $_.IsWebProject } |
	% { 
		$projectName = $_.ProjectName
		gci $_.ProjectDir *.asmx -recurse	
		gci $_.ProjectDir default.aspx
	} | select-object -property:@{Name='Project';Expression={$projectName}},@{Name='Endpoint';Expression={$_.Name}}

popd;