using System;
using System.Collections.Generic;
using System.Text;

namespace Snak.ConfigurationTransformation.Tests
{
    public class TransformationInfo
    {
        private string _environment;

        public string Environment
        {
            get { return _environment; }
        }

        private string _preProcessedFile;

        public string PreProcessedFile
        {
            get { return _preProcessedFile; }
        }

        private string _processedFile;

        public string ProcessedFile
        {
            get { return _processedFile; }
        }

        private bool _inputFileConainsDesiredEnvironment;

        public bool InputFileConainsDesiredEnvironment
        {
            get { return _inputFileConainsDesiredEnvironment; }
        }

        private bool _inputFileConainsDefaultEnvironmentMarkup;

        public bool InputFileConainsDefaultEnvironmentMarkup
        {
            get { return _inputFileConainsDefaultEnvironmentMarkup; }
        }

        public TransformationInfo(string environment, string preProcessedFile, string processedFile, bool inputFileConainsDesiredEnvironment, bool inputFileConainsDefaultEnvironmentMarkup)
        {
            this._environment = environment;
            this._preProcessedFile = preProcessedFile;
            this._processedFile = processedFile;
            this._inputFileConainsDesiredEnvironment = inputFileConainsDesiredEnvironment;
            this._inputFileConainsDefaultEnvironmentMarkup = inputFileConainsDefaultEnvironmentMarkup;
        }

        public override string ToString()
        {
            return "PreProcessedFile:" + this.PreProcessedFile + ", ProcessedFile:" + this.ProcessedFile;
        }
    }
}
