using System;
using System.Collections.Generic;
using System.Text;
using NUnit.Framework;
using Tests.NAnt.Contrib;
using System.IO;

namespace Snak.FunctionalTests
{
    [TestFixture]
    public class StringManipulationFunctionsTests : BuildTestBase
    {
        [Test]
        public void UpperCaseFirstTest()
        {
            try
            {
                string xmlsnippet = String.Format(
                                    @"  <project name=""loadVersionFileTaskTestsProject"">
                                            <loadtasks assembly=""{0}"" />
                                            <echo message=""${{stringManipulation::upperCaseFirst('bob')}}"" />
                                        </project>",
                                    Path.GetFullPath("Snak.dll")
                                );
                
                string result = RunBuild(xmlsnippet);

                Assert.IsTrue(result.IndexOf("Bob") != -1, "First letter of the string 'bob' was not converted to upper case.");
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
                throw;
            }
        }
    }
}
