using System;
using System.IO;

using Snak;
using Snak.Core;

namespace LOCCounter
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length==0)
				throw new ArgumentException("Required path to solution file passed in");
            
			string solutionFile = args[0];
			ISolutionInfo solution = SolutionFactory.GetSolution(solutionFile);

            solution.ConfigurationManager.SetActiveBuildConfigurationAndLoad(new BuildConfiguration("Debug", "Any CPU"));

            Snak.Metrics.LOCCounter counter = new Snak.Metrics.LOCCounter();
			int totalLines = 0;
            foreach (IProjectInfo project in solution)
			{
				int lines = counter.CountLines(project);
				totalLines+=lines;
				Console.WriteLine("Counted {0} lines in {1}", lines, project.ProjectName);
			}
			Console.WriteLine("Total lines: {0}", totalLines);
		}
	}
}
