using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.IO;

namespace Snak.Core
{
    /// <summary>
    /// Helper class to aid in returning properties from a project file as a specific type rather than just a string.
    /// </summary>
    public abstract class AbstractXmlProjectFileParser : ProjectPropertiesParserHelper
    {
        readonly XmlDocument _projectDocument;

        public XmlDocument ProjectDocument
        {
            get { return _projectDocument; }
        }

        readonly XmlNamespaceManager _xmlNamespaceManager;

        public XmlNamespaceManager XmlNamespaceManager
        {
            get { return _xmlNamespaceManager; }
        }

        internal AbstractXmlProjectFileParser(XmlDocument document)
        {

        }

        internal AbstractXmlProjectFileParser(XmlDocument document, XmlNamespaceManager xmlNamespaceManager)
        {
            _projectDocument = document;
            _xmlNamespaceManager = xmlNamespaceManager;
        }

        internal abstract T GetPropertySetting<T>(string propertyName);

        internal abstract T GetPropertySettingForBuildConfig<T>(BuildConfiguration buildConfiguration, string propertyName);
    }
}
