using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Snak.Core
{
    public interface IProjectBuildProperties
    {
        #region common project values (common to most VS projects)

        // of some help in relation to the types of these properties: 
        // http://msdn2.microsoft.com/en-us/library/vslangproj80.projectconfigurationproperties3_properties.aspx

        bool AllowUnsafeBlocks { get; }
        uint BaseAddress { get; }
        bool CheckForOverflowUnderflow { get; }
        FileInfo ConfigurationOverrideFile { get; }
        /// <summary>
        /// Any build constants setup for this project configuration
        /// </summary>
        List<String> DefineConstants { get; }
        FileInfo DocumentationFile { get; }
        bool DebugSymbols { get; }
        string FileAlignment { get; }
        bool IncrementalBuild { get; }
        bool NoStdLib { get; }
        string NoWarn { get; }
        bool Optimize { get; }
        bool RegisterForComInterop { get; }
        bool RemoveIntegerChecks { get; }
        bool TreatWarningsAsErrors { get; }
        int WarningLevel { get; }
        string DebugType { get; }
        string ErrorReport { get; }
        /// <summary>
        /// Either a specially named 'nunit.config' in the project root,
        /// or the same as the project's configuration file, or
        /// </summary>
        FileInfo TestingConfigFile { get; }

        /// <summary>
        /// The relative path to the project's output folder (for this configuration)
        /// </summary>
        string OutputPath { get; }

        /// <summary>
        /// The full path to the project output folder (for this configuration)
        /// </summary>
        string OutputPathFull { get; }

        /// <summary>
        /// The complete path to the project's output assembly
        /// </summary>
        string OutputFilePath { get; }

        #endregion

        #region web site project based values

        /// <summary>
        /// 
        /// </summary>
        string VirtualPath { get; }

        /// <summary>
        /// 
        /// </summary>
        string PhysicalPath { get; }

        /// <summary>
        /// 
        /// </summary>
        string TargetPath { get; }

        /// <summary>
        /// 
        /// </summary>
        bool Updateable { get; }

        /// <summary>
        /// 
        /// </summary>
        bool ForceOverwrite { get; }

        /// <summary>
        /// 
        /// </summary>
        FileInfo KeyFile { get; }

        /// <summary>
        /// 
        /// </summary>
        bool DelaySign { get; }

        /// <summary>
        /// 
        /// </summary>
        string KeyContainer { get; }

        /// <summary>
        /// 
        /// </summary>
        bool AllowPartiallyTrustedCallers { get; }

        /// <summary>
        /// 
        /// </summary>
        bool FixedNames { get; }

        /// <summary>
        /// 
        /// </summary>
        int VWDPort { get; }

        /// <summary>
        /// 
        /// </summary>
        ProjectLanguage DefaultWebSiteLanguage { get; }

        #endregion 
    }
}