using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using Snak.Core;
using NAnt.VSNet.Types;

namespace Snak.Core
{
    public interface ISolutionInfo : IEnumerable<IProjectInfo>
    {      
        /// <summary>
        /// Retrieve the location of the actual solution file
        /// </summary>
        FileInfo SolutionFile { get; }

        /// <summary>
        /// 
        /// </summary>
        ConfigurationManagerState ConfigurationManager { get; }

        /// <summary>
        /// A Dictionary of all the projects
        /// </summary>
        Dictionary<String, IProjectInfo> ProjectsByName { get; }

        /// <summary>
        /// A Dictionary of all the projects
        /// </summary>
        Dictionary<Guid, IProjectInfo> ProjectsByGuid { get; }

        /// <summary>
        /// A collection of maps between URI's (or URI prefixes) and local paths,
        /// to be used when resolving HTTP references for projects
        /// </summary>
        WebMapCollection WebMaps { get; }
    }
}
