using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace Snak.Core
{
    /// <summary>
    /// Thrown when an exception occurred that is core to the internal workings of Snak, 
    /// basically if this is thrown its because Snak is doing something incorrect, not thrown 
    /// when a user interacts with it incorrectly
    /// </summary>
    public class SnakException : ApplicationException
    {
        public SnakException() : base() {}
        public SnakException(string message) : base(message) {}
        protected SnakException(SerializationInfo info, StreamingContext context) : base(info, context) {}
        public SnakException(string message, Exception innerException) : base(message, innerException) { }
    }
}
