using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Snak.Core
{
    /// <summary>
    /// Contains information about the project as found in the solution file
    /// </summary>
    public class SolutionsProjectInfo
    {
        private Guid _projectGuid = Guid.Empty;

        internal Guid ProjectGuid
        {
            get { return _projectGuid; }
            set { _projectGuid = value; }
        }

        private Guid _projectTypeGuid = Guid.Empty;

        internal Guid ProjectTypeGuid
        {
            get { return _projectTypeGuid; }
            set { _projectTypeGuid = value; }
        }

        private string _projectName = String.Empty;

        internal string ProjectName
        {
            get { return _projectName; }
            set { _projectName = value; }
        }

        private FileInfo _projectFile = null;

        internal FileInfo ProjectFile
        {
            get { return _projectFile; }
            set { _projectFile = value; }
        }

        private string _projectSection = String.Empty;

        internal string ProjectSection
        {
            get { return _projectSection; }
            set { _projectSection = value; }
        }

        private DirectoryInfo _projectDir;

        internal DirectoryInfo ProjectDir
        {
            get { return _projectDir; }
            set { _projectDir = value; }
        }

        private bool _hasProjectFile;

        public bool HasProjectFile
        {
            get { return _hasProjectFile; }
            set { _hasProjectFile = value; }
        }

        internal SolutionsProjectInfo(Guid projectGuid, Guid projectTypeGuid, string projectName, FileInfo projectFile, DirectoryInfo projectDir, string projectSection, bool hasProjectFile)
        {
            this._projectGuid = projectGuid;
            this._projectTypeGuid = projectTypeGuid;
            this._projectName = projectName;
            this._projectFile = projectFile;
            this._projectSection = projectSection;
            this._projectDir = projectDir;
            this._hasProjectFile = hasProjectFile;
        }
    }
}
