using System;
using System.Collections.Generic;
using System.Text;
using Snak.Core;
using System.IO;
using System.Text.RegularExpressions;
using System.Reflection;

namespace Snak.Core.Whidbey
{
    public class WhidbeyProjectBuildConfig : AbstractProjectBuildProperties
    {
        private string _solutionFileContents = String.Empty;

        public WhidbeyProjectBuildConfig(BuildConfiguration buildConfiguration, AbstractXmlProjectFileParser xmlProjectFileParser, AbstractProject parentProject)
            : base(parentProject)
        {
            this.BuildConfiguration = buildConfiguration;
            this.AbstractXmlProjectFileParser = xmlProjectFileParser;

            Load();
        }

        private void Load()
        {
            this.AllowPartiallyTrustedCallers = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<bool>(this.BuildConfiguration, "AllowPartiallyTrustedCallers");
            this.AllowUnsafeBlocks = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<bool>(this.BuildConfiguration, "AllowUnsafeBlocks");
            this.BaseAddress = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<uint>(this.BuildConfiguration, "BaseAddress");
            this.CheckForOverflowUnderflow = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<bool>(this.BuildConfiguration, "CheckForOverflowUnderflow");
            this.ConfigurationOverrideFile = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<FileInfo>(this.BuildConfiguration, "ConfigurationOverrideFile");
            this.DefineConstants = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<List<String>>(this.BuildConfiguration, "DefineConstants");
            this.DocumentationFile = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<FileInfo>(this.BuildConfiguration, "DocumentationFile");
            this.DebugSymbols = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<bool>(this.BuildConfiguration, "DebugSymbols");
            this.FileAlignment = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<String>(this.BuildConfiguration, "FileAlignment");
            this.IncrementalBuild = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<bool>(this.BuildConfiguration, "IncrementalBuild");
            this.NoStdLib = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<bool>(this.BuildConfiguration, "NoStdLib");
            this.NoWarn = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<String>(this.BuildConfiguration, "NoWarn");
            this.Optimize = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<bool>(this.BuildConfiguration, "Optimize");
            this.RegisterForComInterop = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<bool>(this.BuildConfiguration, "RegisterForComInterop");
            this.RemoveIntegerChecks = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<bool>(this.BuildConfiguration, "RemoveIntegerChecks");
            this.TreatWarningsAsErrors = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<bool>(this.BuildConfiguration, "TreatWarningsAsErrors");
            this.WarningLevel = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<int>(this.BuildConfiguration, "WarningLevel");
            this.DebugType = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<String>(this.BuildConfiguration, "DebugType");
            this.ErrorReport = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<String>(this.BuildConfiguration, "ErrorReport");
            this.OutputPath = this.AbstractXmlProjectFileParser.GetPropertySettingForBuildConfig<String>(this.BuildConfiguration, "OutputPath");
            this.OutputPathFull = Path.Combine(this.ParentProject.ProjectFile.DirectoryName, this.OutputPath);
        }
    }
}
