using System;
using System.Collections.Generic;
using System.Text;
using Snak.Core;
using System.IO;
using System.Text.RegularExpressions;
using System.Reflection;

namespace Snak.Core.Whidbey
{
    public class WhidbeyWebProjectBuildConfig : AbstractProjectBuildProperties
    {
        private string _solutionFileContents = String.Empty;

        public WhidbeyWebProjectBuildConfig(BuildConfiguration buildConfiguration, AbstractProject parentProject, string solutionFileContents)
            : base(parentProject)
        {
            this.BuildConfiguration = buildConfiguration;
            this._solutionFileContents = solutionFileContents;

            LoadForWebSiteProject();
        }

        private void LoadForWebSiteProject()
        {
            ProjectPropertiesParserHelper projectPropertiesParserHelper = new ProjectPropertiesParserHelper();

            // Debug.AspNetCompiler.VirtualPath = "/FileSystemBasedWebSite"
            string pattern = String.Format(@"{0}\.AspNetCompiler\.(?<propertyName>[^\s]*)?\s*?=\s*?""(?<propertyValue>[^""]*)?", this.BuildConfiguration.Config);

            MatchCollection matchCollection = Regex.Matches(this._solutionFileContents, pattern);

            for (int matchIndex = 0; matchIndex < matchCollection.Count; matchIndex++)
            {
                Match propertyMatch = matchCollection[matchIndex];

                string propertyName = propertyMatch.Groups["propertyName"].Value;
                string propertyValue = propertyMatch.Groups["propertyValue"].Value;

                PropertyInfo property = this.GetType().GetProperty(propertyName);
                
                if (property != null)
                {
                    property.SetValue(this, projectPropertiesParserHelper.TryConvertValue(property.PropertyType, propertyValue), null);
                }
                else
                {
                    //  throw new SnakException("Type no supported.");                    
                    // TODO: log unsupported properties
                }
            }

            // TODO: this seems a bit of a hack.... keith
            //this.OutputPath = Path.Combine(this.ParentProject.ProjectDir.FullName, this.TargetPath);
            //this.OutputPathFull = this.OutputPath; 
            this.OutputPath = this.ParentProject.ProjectDir.FullName;
            this.OutputPathFull = this.OutputPath;
        }
    }
}
