using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace Snak.Core.Whidbey
{
    internal class WhidbeyXmlProjectFileParser : AbstractXmlProjectFileParser
    {
        internal WhidbeyXmlProjectFileParser(XmlDocument document, XmlNamespaceManager xmlNamespaceManager) : base(document, xmlNamespaceManager) { }
        
        internal override T GetPropertySetting<T>(string propertyName)
        {
            string noteValue = String.Empty;

            XmlElement foundNode = null;

            if (foundNode == null)
                foundNode = (XmlElement)this.ProjectDocument.SelectSingleNode(string.Format("/ms:Project/ms:PropertyGroup/ms:{0}", propertyName), this.XmlNamespaceManager);

            if (foundNode != null)
                noteValue = foundNode.InnerText;

            return this.TryConvertValue<T>(noteValue);
        }

        internal override T GetPropertySettingForBuildConfig<T>(BuildConfiguration buildConfiguration, string propertyName)
        {
                // xpath example:  //Project/PropertyGroup[@Condition=" '$(Configuration)|$(Platform)' == 'Debug|.Net' "]/OutputPath

                string xpath = String.Format(@"/ms:Project/ms:PropertyGroup[@Condition="" '$(Configuration)|$(Platform)' == '{0}' ""]/ms:{1}", buildConfiguration.ToString(), propertyName);

                string noteValue = String.Empty;

                XmlElement foundNode = null;

                if (foundNode == null)
                    foundNode = (XmlElement)this.ProjectDocument.SelectSingleNode(string.Format("/ms:Project/ms:PropertyGroup/ms:{0}", propertyName), this.XmlNamespaceManager);

                if (foundNode != null)
                    noteValue = foundNode.InnerText;

                return this.TryConvertValue<T>(noteValue);
        }
    }
}
