using System;
using System.IO;
using NAnt.Core;
using NAnt.Core.Attributes;

using Snak.ConfigurationTransformation;
using NAnt.Core.Types;

namespace Snak.Tasks
{
    /// <summary>
    /// Summary description for ConfigurationFileTransformer.
    /// </summary>
    [TaskName("transformConfigurationFiles")]
    public class TransformConfigurationFilesTask : Task
    {
        private string _targetEnvironment = String.Empty;

        private FileSet _items = null;

        /// <summary>
        /// the items to transform
        /// </summary>
        [BuildElement("items", Required = true)]
        public FileSet Items
        {
            get { return _items; }
            set { _items = value; }
        }

        [TaskAttribute("targetEnvironment", Required = true)]
        public string TargetEnvironment
        {
            get { return _targetEnvironment; }
            set { _targetEnvironment = value; }
        }

        public TransformConfigurationFilesTask()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        protected override void ExecuteTask()
        {
            foreach (string fileName in _items.FileNames)
            {
                ConfigurationTransformer transformer = new ConfigurationTransformer();
                transformer.Transform(_targetEnvironment, fileName, fileName);
            }
        }
    }
}
