using System;
using System.IO;

namespace Snak.Utilities
{
	/// <summary>
	/// Provides a block-scope during which time a file is made writable
	/// </summary>
	internal class WritableFileScope : IDisposable
	{
		private FileInfo _file;
		private FileAttributes _originalAttributes;

		public WritableFileScope(FileInfo file)
		{
			_file = file;
			_originalAttributes = _file.Attributes;
			_file.Attributes = FileAttributes.Normal;
		}

		public void Dispose()
		{
			_file.Attributes = _originalAttributes;
		}
	}
}
